#define INTERNAL_NODE MAX+1

typedef struct nodetype
 {
  long long weight;
  int symbol;
  struct nodetype *left, *right, *parent; /* tree structure */ 
  struct nodetype *next, *prev; /* doubly-linked list */
  struct nodetype **head; /* highest ranked node in block */
 } Node;

void dumptree(Node *node);
void dumplist(Node *node);
void usage(char **argv);
void swap (Node *node1, Node *node2);
void swaplist(Node *node1, Node *node2);
void increment(Node *node,int);
void checkranks(Node *node);
void add_ref(int ch);

Node **GX3;

Node **get_ppnode(void);
